SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 19:16'!
createCartWithAnElementInCatalog:anElement andPrice: aPrice 
| aCart  aCtalogue aPriceListItem |

      aCart := Cart new.
	
	aCtalogue:= Dictionary new.
	aPriceListItem := Association new.
	aPriceListItem key: anElement value: aPrice. 
	aCtalogue add: aPriceListItem.
	aCart initializeWithCatalogue: aCtalogue.
	^ aCart.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 20:33'!
createCashierAlwaysInsuficient

| aCashier aTranslator |
aCashier := Cashier new.
aTranslator := StubUITranslator new.
aTranslator initializeWithMessage: '$ INSUFICIENTCREDIT $'.
^aCashier initializeWithCreditCardVerificator: aTranslator .! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 20:33'!
createCashierAlwaysStolen

| aCashier aTranslator |
aCashier := Cashier new.
aTranslator := StubUITranslator new.
aTranslator initializeWithMessage: '$ CREDIT CARD STOLEN $'.
^aCashier initializeWithCreditCardVerificator: aTranslator .! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 20:40'!
createDefaultCreditCardWithExpirationDate: aDate

	| aCardID anOwner aCreditCard  |
	aCardID:= '334563'.
	anOwner := 'Tobias'.
	^aCreditCard := CreditCard  CreateWithID: aCardID  expiration: aDate  andOwner: anOwner .! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'autor 6/9/2013 16:32'!
createRestInterfaceWithCartCatalogueWithCartID1
	| anElement anAssociation aRestInterface aPrice aCart anId |
	aRestInterface := RestInterface new.
	anElement := 'LOTR'.
	aPrice := 7.
	aCart := self createCartWithAnElementInCatalog: anElement andPrice: aPrice.
	anId := '1'.
	anAssociation := Association new.
	anAssociation key: anId value: aCart.
	aRestInterface cartCatalogue add: anAssociation.
	^ aRestInterface! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'autor 6/9/2013 17:32'!
createRestInterfaceWithCartCatalogueWithCartID1anCartWithElement
	| anElement anAssociation aRestInterface aPrice aCart anId |
	aRestInterface := RestInterface new.
	anElement := 'LOTR'.
	aPrice := 7.
	aCart := self createCartWithAnElementInCatalog: anElement andPrice: aPrice.
	anId := '1'.
	aCart add: anElement.
	anAssociation := Association new.
	anAssociation key: anId value: aCart.
	aRestInterface cartCatalogue add: anAssociation.
	^ aRestInterface! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'autor 6/9/2013 19:42'!
createRestInterfaceWithCartCatalogueWithCartID1anCartWithElementandClock: aClock
	| anElement anAssociation aRestInterface aPrice aCart anId |
	aRestInterface := RestInterface createRestInterfaceWith: aClock.
	anElement := 'LOTR'.
	aPrice := 7.
	aCart := self createCartWithAnElementInCatalog: anElement andPrice: aPrice.
	anId := '1'.
	aCart add: anElement.
	anAssociation := Association new.
	anAssociation key: anId value: aCart.
	(aRestInterface cartCatalogue) add: anAssociation.
	^ aRestInterface! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 20:56'!
test01newCartMustBeEmptyOnCreation

	| aCart |
	aCart := Cart new.
	self assert: aCart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'tuVieja 6/3/2013 18:30'!
test03cartMustNotBeEmptyAfterAddingABook
	
	|aCart aCatalog aPriceListItem |
	
	aCart := Cart new.
	aCatalog:= Dictionary new.
	aPriceListItem := Association new.
	aPriceListItem key: 'LOTR'  value: 5 .
	aCatalog add: aPriceListItem.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: 'LOTR'.
	self deny: aCart isEmpty.! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'FacundoPippia 5/29/2013 21:10'!
test04cannotAddBookIfItIsNotPresentInCatalogue
	
	|aCart aBook|
	
	aCart := Cart new.
	
	aBook := 'LOTR'.
	
	
	self should: [ aCart add: aBook. self assert: (aCart hasItem: aBook) .] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = '$NOT IN CATALOGUE$' ].

	! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'tuVieja 6/3/2013 18:32'!
test05OnlyAddedBookMustBeInCartAfterAddition
	
	|aCart aBook aCatalog aPriceListItem |
	
	aCart := Cart new.
	aBook := 'LOTR'.
	aCatalog:= Dictionary new.
	aPriceListItem := Association new.
	aPriceListItem key: aBook value: 5. 
	aCatalog add: aPriceListItem.
	aCart initializeWithCatalogue: aCatalog.
	aCart add: aBook.

	self assert: (aCart hasItem: aBook).
	self assert:( aCart numberofCartElements = 1 ).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/5/2013 19:40'!
test06cannotCheckoutAnEmptyCart
	| aCart aCashier aSalesBookBeforeSale aCreditCard aDate |
	aCart := Cart new.
	aCashier := Cashier new.
	aCreditCard := CreditCard new.
	aDate := Date new.
	aSalesBookBeforeSale := aCashier salesBook copy.
	self should: [ aCashier checkout: aCart with: aCreditCard onDate: aDate.] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = ' $CANNOT CHECKOUT AN EMPTY CART$' ) ].
	self assert: aSalesBookBeforeSale = (aCashier salesBook).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/5/2013 20:15'!
test07calculationForSingleElementCartReturnsElementsPrice
	"NEED FOR BETTER NAME"
	| aCashier aCart anElement aPrice |
	
	anElement:='LOTR'.
	aPrice:= 5.
	aCart := self createCartWithAnElementInCatalog: anElement andPrice: aPrice. 
	aCart add:  anElement.
	aCashier := Cashier new.
	
	self assert: (aCashier calculateTotalofCart: aCart) equals: aPrice .
	 ! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/10/2013 23:29'!
test08bisOnlyGeneratedSaleisAddedToSalesBook

	| aCashier aCart aCreditCard resultingSale anID aName aPrice anElement anExpirationDate aCurrentDate |

	aPrice:=5.
	anElement:='LOTR'.
	aCart := self createCartWithAnElementInCatalog:anElement andPrice: aPrice. 
	aCart add:anElement.
	aCashier := Cashier new.
	
	aCurrentDate := Date today.
	anExpirationDate := aCurrentDate addDays: 215.
	
	anID:='59595'.
	aName := 'Pepe'.
	aCreditCard := CreditCard  CreateWithID: anID expiration: anExpirationDate andOwner: aName .
	resultingSale := aCashier checkout: aCart with: aCreditCard onDate: aCurrentDate.


	self assert: ( aCashier salesBook includes: resultingSale  ).
	self assert: ( (aCashier salesBook size) = 1 ).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/10/2013 23:29'!
test08generatedSaleMatchesInputParameters

	| aCashier aCart aCreditCard resultingSale anID aName aPrice anElement newSet anExpirationDate aCurrentDate |

	aPrice:=5.
	anElement:='LOTR'.
	aCart := self createCartWithAnElementInCatalog:anElement andPrice: aPrice. 
	aCart add:anElement.
	aCashier := Cashier new.
	
	aCurrentDate := Date today.
	anExpirationDate := aCurrentDate addDays: 215.
	
	anID:='59595'.
	aName := 'Pepe'.
	aCreditCard := CreditCard  CreateWithID: anID expiration: anExpirationDate andOwner: aName .
	resultingSale := aCashier checkout: aCart with: aCreditCard onDate: aCurrentDate.


	newSet := Set new.
	newSet add: anElement.

	
	self assert: resultingSale = ( Sale CreateWithElements: newSet andTotal: aPrice onDate: aCurrentDate by: aCashier forCardID: anID  )  .! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/5/2013 20:25'!
test09cannotCheckoutWithExpiratedCard

	| aCart aCashier aSalesBookBeforeSale aCreditCard aPrice anElement aCardID anOwner anExpirationDate aCurrentDate |
	
	aPrice:=5.
	anElement:='LOTR'.
	aCart := self createCartWithAnElementInCatalog:anElement andPrice: aPrice. 
	aCart add:anElement.
	
	aCashier := Cashier new.
	
	
	aCardID:= '334563'.
	anOwner := 'Tobias'.
	anExpirationDate := Date today.
	aCurrentDate := anExpirationDate copy.
	aCurrentDate :=aCurrentDate addDays: 67.
	aCreditCard := CreditCard  CreateWithID: aCardID  expiration: anExpirationDate  andOwner: anOwner .
	aSalesBookBeforeSale := aCashier salesBook copy.
	
	self should: [ aCashier checkout: aCart with: aCreditCard onDate: aCurrentDate.] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = ' $CANNOT CHECKOUT WITH EXPIRED CREDIT CARD$' ) ].
	self assert: (aSalesBookBeforeSale = (aCashier salesBook)).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/5/2013 20:41'!
test10cannotCheckoutWithStolenCard

	| aCart aCashier aSalesBookBeforeSale aCreditCard aPrice anElement aCurrentDate anExpirationDate |
	
	aPrice:=5.
	anElement:='LOTR'.
	aCart := self createCartWithAnElementInCatalog:anElement andPrice: aPrice. 
	aCart add:anElement.
	
	
	aCashier := self createCashierAlwaysStolen.
	
	
	
	
	aCurrentDate := Date today.
	anExpirationDate := Date today.
	anExpirationDate :=anExpirationDate addDays: 67.

	aCreditCard := self createDefaultCreditCardWithExpirationDate: anExpirationDate .

	aSalesBookBeforeSale := aCashier salesBook copy.
	
	self should: [ aCashier checkout: aCart with: aCreditCard onDate: aCurrentDate.] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = '$ CREDIT CARD STOLEN $' ) ].
	self assert: (aSalesBookBeforeSale = (aCashier salesBook)).! !

!TusLibrosTest methodsFor: '2 - Test cashier' stamp: 'tuVieja 6/5/2013 20:41'!
test11cannotCheckoutWithCreditlessCard

	| aCart aCashier aSalesBookBeforeSale aCreditCard aPrice anElement aCurrentDate anExpirationDate |
	
	aPrice:=5.
	anElement:='LOTR'.
	aCart := self createCartWithAnElementInCatalog:anElement andPrice: aPrice. 
	aCart add:anElement.
	
	aCashier := self createCashierAlwaysInsuficient .
	
	aCurrentDate := Date today.
	anExpirationDate := Date today.
	anExpirationDate :=anExpirationDate addDays: 67.
	
	aCreditCard := self createDefaultCreditCardWithExpirationDate: anExpirationDate.
	
	aSalesBookBeforeSale := aCashier salesBook copy.
	
	self should: [ aCashier checkout: aCart with: aCreditCard onDate: aCurrentDate.] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = '$ INSUFICIENTCREDIT $') ].
	self assert: (aSalesBookBeforeSale = (aCashier salesBook)).! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'autor 6/9/2013 15:49'!
test12cannotLoginWithInvalidUser


| aRegister aUser aPassword |
aRegister := RestInterface new.
aUser:='Montoto'.
aPassword := '666'.

self should: [ aRegister login: aUser withPassword: aPassword.] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = ' $ LOGIN USER NOT FOUND $' ) ].! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'tuVieja 6/10/2013 23:37'!
test13cannotLoginWithInvalidPassword



| aRegister aUser aPassword aWrongPassword  |
aRegister := RestInterface new.
aUser:='Montoto'.
aPassword :='5515'.
aWrongPassword:='1111'.

aRegister registerUser: aUser withPassword: aPassword.

self should: [ aRegister login: aUser withPassword: aWrongPassword .] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = ' $ LOGIN INVALID PASSWORD $' ) ].

! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'tuVieja 6/10/2013 23:37'!
test14LoginWithValidUsernameAndPassword


| aRegister aUser aPassword   |
aRegister := RestInterface new.

aUser:='Montoto'.
aPassword :='5515'.

aRegister registerUser: aUser withPassword: aPassword. 

self assert: (aRegister login: aUser withPassword: aPassword) equals: '$ LOGIN SUCCESSFUL $'.

! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'tuVieja 6/10/2013 23:38'!
test15cannotAddToCartWithID5IfCartsIDis1
	| aRestInterface anElement aWrongId |
	aRestInterface := self createRestInterfaceWithCartCatalogueWithCartID1.
	anElement := 'LOTR'.
	aWrongId := '5'.
	self
		should: [ aRestInterface add: anElement toCart: aWrongId Quantity: 1 ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = '$ CART NOT IN CATALOGUE $' ]! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'tuVieja 6/10/2013 23:20'!
test16addItemToCart
	| aRestInterface anElement anId aCartBeforeAdd |
	aRestInterface := self createRestInterfaceWithCartCatalogueWithCartID1.
	anElement := 'LOTR'.
	anId := '1'.
	aCartBeforeAdd := self createCartWithAnElementInCatalog: anElement andPrice: 7.
	aRestInterface add: anElement toCart: anId Quantity: 1.
	aCartBeforeAdd add: anElement.
	self assert: aCartBeforeAdd = (aRestInterface cartCatalogue at: anId)! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'autor 6/9/2013 17:23'!
test17cannotListCartThatIsNotInCatalogue
	|  aRestInterface aWrongId |

	aRestInterface := self createRestInterfaceWithCartCatalogueWithCartID1.
	aWrongId := '5'.
		
	self should: [ aRestInterface listCart: aWrongId .] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText = '$ CART NOT IN CATALOGUE $'  ) ].! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'autor 6/9/2013 17:31'!
test18listCart

	|  aRestInterface anElement anId anExpectedContent |

	aRestInterface := self createRestInterfaceWithCartCatalogueWithCartID1anCartWithElement.
	
	anElement := 'LOTR'.
	anId := '1'.
	anExpectedContent := Bag new.
	anExpectedContent add:anElement .
	
	
	
	self assert: anExpectedContent = (aRestInterface listCart: anId  ) . ! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'tuVieja 6/10/2013 23:20'!
test19CannotAddToCartIf30MinutesPassedSinceModification
	| aRestInterface aClock anElement aPassedClock anId |
	aClock := DateAndTime current.
	aRestInterface := self createRestInterfaceWithCartCatalogueWithCartID1anCartWithElementandClock: aClock.
	anElement := 'LOTR'.
	anId := '1'.
	aRestInterface add: anElement toCart: anId Quantity: 1.
	aPassedClock := DateAndTime tomorrow.
	aRestInterface := RestInterface
		createRestInterfaceWithLastModifiedRegister: aRestInterface LastModifiedCartRecord
		andClock: aPassedClock
		andUserCatalogue: aRestInterface userCatalogue
		andCartCatalogue: aRestInterface cartCatalogue.
	self
		should: [ aRestInterface add: anElement toCart: anId Quantity: 1 ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = '$ TIME OUT $' ]! !

!TusLibrosTest methodsFor: '3 - Test RestInterface' stamp: 'tuVieja 6/10/2013 23:20'!
test20CannotListCartIf30MinutesPassedSinceModification
	| aRestInterface aClock anElement aPassedClock anId |
	aClock := DateAndTime current.
	aRestInterface := self createRestInterfaceWithCartCatalogueWithCartID1anCartWithElementandClock: aClock.
	anElement := 'LOTR'.
	anId := '1'.
	aRestInterface add: anElement toCart: anId Quantity: 1.
	aPassedClock := DateAndTime tomorrow.
	aRestInterface := RestInterface
		createRestInterfaceWithLastModifiedRegister: aRestInterface LastModifiedCartRecord
		andClock: aPassedClock
		andUserCatalogue: aRestInterface userCatalogue
		andCartCatalogue: aRestInterface cartCatalogue.
	self
		should: [ aRestInterface listCart: anId ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = '$ TIME OUT $' ]! !

Object subclass: #Cart
	instanceVariableNames: 'content catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:36'!
createWithcatalogue: aCatalogue
 	| cartToReturn |
	cartToReturn := self new.
	^cartToReturn initializeWithCatalogue: aCatalogue. ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 16:54'!
= aCart
^(catalogue = aCart catalogue )and: (content = aCart elements).! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Anonymous 6/3/2013 18:27'!
add: aBook
	( catalogue keys includes: aBook ) ifFalse: [self error:'$NOT IN CATALOGUE$'.].
	^content add: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:23'!
catalogue
	^ catalogue copy.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:23'!
elements 
	^content copy.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:31'!
hasItem: aBook
	^ content includes: aBook.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 18:27'!
hasItemInCatalog:anItem

^ catalogue keys  includes: anItem.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Anonymous 6/3/2013 18:26'!
initialize 
	catalogue := Dictionary new.
	content:= Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 20:13'!
initializeWithCatalogue: aCatalogue
	catalogue := aCatalogue.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 17:43'!
isEmpty
	^content size = 0.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TuVieja 5/29/2013 19:23'!
numberofCartElements
	^ content size.! !

Object subclass: #Cashier
	instanceVariableNames: 'salesBook creditCardVerifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 20:04'!
createWithCreditCardVerificator: aTranslator 

|cashierToReturn|
cashierToReturn  := self new.
^cashierToReturn  initializeWithCreditCardVerificator: aTranslator.
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:34'!
calculateTotalofCart: aCart
	| cartContent price |
	cartContent := aCart elements.
	price := 0.
"	cartContent
		collect: [ :anElement | price := price + (aCart catalogue at: anElement * (cartContent occurrencesOf: anElement)) ].
"	^cartContent sum: [ :anElement | (aCart catalogue at: anElement)  * (cartContent occurrencesOf: anElement)].! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 18:39'!
checkout: aCart with: aCreditCard onDate: aDate
	| aSale |
	(aCart isEmpty )ifTrue:[self error: ' $CANNOT CHECKOUT AN EMPTY CART$'].
	(aCreditCard expiration < aDate )ifTrue:[self error: ' $CANNOT CHECKOUT WITH EXPIRED CREDIT CARD$'].
	self verifierMachine  verifyCreditCard: aCreditCard.
	aSale := Sale new .
	aSale initializeWithElements: ( aCart elements asSet ) andTotal: (self calculateTotalofCart: aCart)  onDate: (aDate) by: (self)  forCardID: ( aCreditCard cardID ).
	salesBook add: aSale.
	^ aSale.
! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 21:52'!
initialize 
salesBook := Set new.
creditCardVerifier := UITransLator new.


! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 18:36'!
initializeWithCreditCardVerificator: aTranslator.
salesBook := Set new.
creditCardVerifier := aTranslator.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 20:57'!
salesBook
	^salesBook copy.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 18:38'!
verifierMachine
	^creditCardVerifier! !

Object subclass: #CreditCard
	instanceVariableNames: 'expiration id owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 20:10'!
CreateWithID: anID expiration: aDate andOwner: aName 

	|aCreditCard|

aCreditCard := self new.
^ aCreditCard initializeWithID: anID expiration: aDate  andOwner: aName. ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:28'!
cardID
	^ id.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/3/2013 21:12'!
expiration
	^expiration ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:15'!
initializeWithID: anId expiration: aDate andOwner: aName 
expiration := aDate.
id:= anId.
owner:= aName.

! !

Object subclass: #RestInterface
	instanceVariableNames: 'cartCatalogue UserCatalogue Clock LastModifiedCartRecord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!RestInterface class methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 19:43'!
createRestInterfaceWith: aDateAndTime

	| restInterface |
	
	restInterface :=  self new.
	^restInterface initializeClockWith:  aDateAndTime. ! !

!RestInterface class methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 19:43'!
createRestInterfaceWithLastModifiedRegister: aRegister andClock: aClock andUserCatalogue:aUserCatalogue andCartCatalogue: aCartCatalogue
| aRestInterface |
aRestInterface := self new.
^aRestInterface initializeRestInterfaceWithLastModifiedRegister: aRegister andClock: aClock andUserCatalogue:aUserCatalogue andCartCatalogue: aCartCatalogue! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 18:30'!
LastModifiedCartRecord
	^LastModifiedCartRecord! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/10/2013 23:19'!
add: anElement toCart: anId Quantity: aQuantity 
| anAssociation containsKey |
((self cartCatalogue) includesKey: anId )ifFalse:[ self error: '$ CART NOT IN CATALOGUE $' .].


containsKey := self LastModifiedCartRecord includesKey: anId.
(containsKey) ifTrue: [ 
	
	(((self clock - (self LastModifiedCartRecord at:anId ) ) asSeconds) > (30*60)) ifTrue:[ self error: '$ TIME OUT $' .].
	 ].

anAssociation := Association new. 
anAssociation key:anId value: self clock.
self LastModifiedCartRecord add: anAssociation .
aQuantity timesRepeat: [(self cartCatalogue at:anId) add: anElement.]
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 16:25'!
cartCatalogue
 ^ cartCatalogue ! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 19:18'!
clock 
^ Clock! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 18:07'!
initialize 
cartCatalogue := Dictionary new.
UserCatalogue  := Dictionary new.
LastModifiedCartRecord := Dictionary new.
Clock :=  DateAndTime new.
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 18:12'!
initializeClockWith: aDateAndTime 
	Clock :=  aDateAndTime.
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 19:37'!
initializeRestInterfaceWithLastModifiedRegister: aRegister andClock: aClock andUserCatalogue:aUserCatalogue andCartCatalogue: aCartCatalogue
 LastModifiedCartRecord := aRegister.
 Clock := aClock.
 UserCatalogue := aUserCatalogue .
 cartCatalogue := aCartCatalogue .
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/10/2013 22:57'!
listCart:anId

| anAssociation containsKey |

((self cartCatalogue) includesKey: anId )ifFalse:[ self error: '$ CART NOT IN CATALOGUE $' .].
containsKey := self LastModifiedCartRecord includesKey: anId.
(containsKey) ifTrue: [ 
	
	(((self clock - (self LastModifiedCartRecord at:anId ) ) asSeconds) > (30*60)) ifTrue:[ self error: '$ TIME OUT $' .].
	 ].

anAssociation := Association new. 
anAssociation key:anId value: self clock.
self LastModifiedCartRecord add: anAssociation .
^(self cartCatalogue at:anId) elements.
! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 15:52'!
login:aUser withPassword: aPassword
((self userCatalogue) includesKey: aUser )ifFalse:[ self error: ' $ LOGIN USER NOT FOUND $' .].
( (self userCatalogue at:aUser) = aPassword  )ifFalse:[ self error: ' $ LOGIN INVALID PASSWORD $' .].
^'$ LOGIN SUCCESSFUL $'! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/10/2013 23:35'!
registerUser: aUser withPassword: aPassword 

| anAssociation |
anAssociation := Association new.
anAssociation key: aUser value: aPassword  .
self userCatalogue  add: anAssociation . ! !

!RestInterface methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 21:23'!
userCatalogue
 ^ UserCatalogue ! !

Object subclass: #Sale
	instanceVariableNames: 'cashier clientCardID salesDate total elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 20:13'!
CreateWithElements: aSet andTotal: aNumber onDate: aDate by: aCashier forCardID: aCardId

|aSale|

aSale := self new.
^aSale initializeWithElements: aSet andTotal: aNumber  onDate: aDate by: aCashier forCardID: aCardId . ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'autor 6/9/2013 17:04'!
= aSale 
^cashier = aSale cashier and: ( ( salesDate = aSale salesDate) and: ( (total = aSale total) and: ( elements = aSale elements) ) )  ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:35'!
cashier
^ cashier.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:37'!
clientID
^ clientCardID .

	! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:36'!
elements
^elements.
	! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:46'!
initialize
cashier := Cashier new  .
salesDate := Date new .
total:= 0.
elements:= Set new.
clientCardID := 0 .

	! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:23'!
initializeWithElements: aSet andTotal: aNumber onDate: aDate by: aCashier forCardID: aCardId
cashier := aCashier  .
salesDate := aDate .
total:= aNumber.
elements:= aSet.
clientCardID := aCardId .

	! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:35'!
salesDate
^salesDate ! !

!Sale methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 17:36'!
total
^total.! !

Object subclass: #StubUITranslator
	instanceVariableNames: 'errorMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!StubUITranslator methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 18:23'!
initializeWithMessage:aString 
errorMessage  := aString.! !

!StubUITranslator methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 18:56'!
verifyCreditCard:aCreditCard
self error:errorMessage! !

Object subclass: #UITransLator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!UITransLator methodsFor: 'as yet unclassified' stamp: 'tuVieja 6/5/2013 18:24'!
verifyCreditCard:aCreditCard
! !
